"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var Linker = function (system) {
    var linked = [];
    var link = function (payload) { return __awaiter(_this, void 0, void 0, function () {
        var _a, status, body, ex_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, system.post(payload.host + "/authenticate", {
                            password: payload.password,
                        })];
                case 1:
                    _a = _b.sent(), status = _a.status, body = _a.body;
                    if (status === 200) {
                        linked.push({ host: payload.host, token: body.token });
                        return [2 /*return*/, { success: true, response: undefined }];
                    }
                    else {
                        return [2 /*return*/, { success: false, response: body }];
                    }
                    return [3 /*break*/, 3];
                case 2:
                    ex_1 = _b.sent();
                    return [2 /*return*/, { success: false, response: "Failed to authenticate with external host (" + payload.host + ")." }];
                case 3: return [2 /*return*/];
            }
        });
    }); };
    var getLinkedForService = function (name) { return __awaiter(_this, void 0, void 0, function () {
        var _i, linked_1, linkedService, body, ex_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    _i = 0, linked_1 = linked;
                    _a.label = 1;
                case 1:
                    if (!(_i < linked_1.length)) return [3 /*break*/, 4];
                    linkedService = linked_1[_i];
                    return [4 /*yield*/, system.post(linkedService.host + "/colosseum/services/" + linkedService.token, {})];
                case 2:
                    body = (_a.sent()).body;
                    if (body.find(function (service) { return service.name === name; })) {
                        return [2 /*return*/, linkedService];
                    }
                    _a.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 6];
                case 5:
                    ex_2 = _a.sent();
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    }); };
    var message = function (name, messageName, payload) { return __awaiter(_this, void 0, void 0, function () {
        var linkedForService, host, token, body, ex_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getLinkedForService(name)];
                case 1:
                    linkedForService = _a.sent();
                    if (!linkedForService) return [3 /*break*/, 5];
                    host = linkedForService.host, token = linkedForService.token;
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, system.post(host + "/" + name + "/" + messageName + "/" + token, payload)];
                case 3:
                    body = (_a.sent()).body;
                    return [2 /*return*/, { success: true, response: body }];
                case 4:
                    ex_3 = _a.sent();
                    return [2 /*return*/, { success: false, response: "Failed to message external host (" + host + ")." }];
                case 5: return [2 /*return*/];
            }
        });
    }); };
    return {
        link: link,
        message: message,
    };
};
exports.default = Linker;
//# sourceMappingURL=Linker.js.map